Botan 2.19.5 Crypto and TLS for C&

Public Member Functions | Public Attributes | List of all members
Botan::X509_Cert_Options Class Referencefinal

`#include <x509self.h>`

## Public Member Functions
void | add_constraints (Key_Constraints constr)
void | add_ex_constraint (const OID &oid)
void | add_ex_constraint (const std::string &name)
void | CA_key (size_t limit=1)
void | not_after (const std::string &time)
void | not_before (const std::string &time)
void | set_padding_scheme (const std::string &scheme)
| X509_Cert_Options (const std::string &opts="", uint32_t expire_time=365 *24 *60 *60)

## Public Attributes
std::string | challenge
std::string | common_name
Key_Constraints | constraints
std::string | country
std::string | dns
std::string | email
X509_Time | end
std::vector< OID > | ex_constraints
Extensions | extensions
std::string | ip
bool | is_CA
std::string | locality
std::vector< std::string > | more_dns
std::vector< std::string > | more_org_units
std::string | org_unit
std::string | organization
std::string | padding_scheme
size_t | path_limit
std::string | serial_number
X509_Time | start
std::string | state
std::string | uri
std::string | xmpp

## Detailed Description

Options for X.509 certificates.

Definition at line 23 of file x509self.h.

## Constructor & Destructor Documentation

## ◆ X509_Cert_Options()

Botan::X509_Cert_Options::X509_Cert_Options | ( | const std::string & | opts = `""`,
|  | uint32_t | expire_time = `365 * 24 * 60 * 60`
| ) |  |

Construct a new options object

Parameters

  opts | define the common name of this object. An example for this parameter would be "common_name/country/organization/organizational_unit".
  expire_time | the expiration time (from the current clock in seconds)

Definition at line 71 of file x509opt.cpp.

73 {
74 is_CA = false;
75 path_limit = 0;
76 constraints = NO_CONSTRAINTS;
77 // use default for chosen algorithm
78 padding_scheme = "";
79
80 auto now = std::chrono::system_clock::now();
81
82 start = X509_Time(now);
83 end = X509_Time(now + std::chrono::seconds(expiration_time));
84
85 if(initial_opts.empty())
86 return;
87
88 std::vector<std::string> parsed = split_on(initial_opts, '/');
89
90 if(parsed.size() > 4)
91 throw Invalid_Argument("X.509 cert options: Too many names: "
92 + initial_opts);
93
94 if(parsed.size() >= 1) common_name = parsed[0];
95 if(parsed.size() >= 2) country = parsed[1];
96 if(parsed.size() >= 3) organization = parsed[2];
97 if(parsed.size() == 4) org_unit = parsed[3];
98 }
Botan::X509_Cert_Options::common_name
std::string common_name
Definition: x509self.h:29
Botan::X509_Cert_Options::org_unit
std::string org_unit
Definition: x509self.h:44
Botan::X509_Cert_Options::constraints
Key_Constraints constraints
Definition: x509self.h:125
Botan::X509_Cert_Options::is_CA
bool is_CA
Definition: x509self.h:113
Botan::X509_Cert_Options::country
std::string country
Definition: x509self.h:34
Botan::X509_Cert_Options::end
X509_Time end
Definition: x509self.h:108
Botan::X509_Cert_Options::organization
std::string organization
Definition: x509self.h:39
Botan::X509_Cert_Options::start
X509_Time start
Definition: x509self.h:104
Botan::X509_Cert_Options::path_limit
size_t path_limit
Definition: x509self.h:118
Botan::X509_Cert_Options::padding_scheme
std::string padding_scheme
Definition: x509self.h:120
Botan::X509_Time
ASN1_Time X509_Time
Definition: asn1_obj.h:386
Botan::split_on
std::vector< std::string > split_on(const std::string &str, char delim)
Definition: parsing.cpp:148
Botan::NO_CONSTRAINTS
@ NO_CONSTRAINTS
Definition: pkix_enums.h:107

References common_name, constraints, country, end, is_CA, Botan::NO_CONSTRAINTS, org_unit, organization, padding_scheme, path_limit, Botan::split_on(), and start.

## Member Function Documentation

## ◆ add_constraints()

void Botan::X509_Cert_Options::add_constraints | ( | Key_Constraints | constr | ) |

Add the key constraints of the KeyUsage extension.

Parameters

  constr | the constraints to set

Definition at line 33 of file x509opt.cpp.

34 {
35 constraints = usage;
36 }

References constraints.

## ◆ add_ex_constraint() [1/2]

void Botan::X509_Cert_Options::add_ex_constraint | ( | const OID & | oid | ) |

Add constraints to the ExtendedKeyUsage extension.

Parameters

  oid | the oid to add

Definition at line 41 of file x509opt.cpp.

42 {
43 ex_constraints.push_back(oid);
44 }
Botan::X509_Cert_Options::ex_constraints
std::vector< OID > ex_constraints
Definition: x509self.h:130

References ex_constraints.

## ◆ add_ex_constraint() [2/2]

void Botan::X509_Cert_Options::add_ex_constraint | ( | const std::string & | name | ) |

Add constraints to the ExtendedKeyUsage extension.

Parameters

  name | the name to look up the oid to add

Definition at line 49 of file x509opt.cpp.

50 {
51 ex_constraints.push_back(OID::from_string(oid_str));
52 }
Botan::OID::from_string
static OID from_string(const std::string &str)
Definition: asn1_oid.cpp:62

References ex_constraints, and Botan::OID::from_string().

## ◆ CA_key()

void Botan::X509_Cert_Options::CA_key | ( | size_t | limit = `1` | ) |

Mark the certificate as a CA certificate and set the path limit.

Parameters

  limit | the path limit to be set in the BasicConstraints extension.

Definition at line 57 of file x509opt.cpp.

58 {
59 is_CA = true;
60 path_limit = limit;
61 }

References is_CA, and path_limit.

## ◆ not_after()

void Botan::X509_Cert_Options::not_after | ( | const std::string & | time | ) |

Set the notAfter of the certificate.

Parameters

  time | the notAfter value of the certificate

Definition at line 25 of file x509opt.cpp.

26 {
27 end = X509_Time(time_string, ASN1_Tag::UTC_OR_GENERALIZED_TIME);
28 }
Botan::UTC_OR_GENERALIZED_TIME
@ UTC_OR_GENERALIZED_TIME
Definition: asn1_obj.h:56

References end, and Botan::UTC_OR_GENERALIZED_TIME.

## ◆ not_before()

void Botan::X509_Cert_Options::not_before | ( | const std::string & | time | ) |

Set the notBefore of the certificate.

Parameters

  time | the notBefore value of the certificate

Definition at line 17 of file x509opt.cpp.

18 {
19 start = X509_Time(time_string, ASN1_Tag::UTC_OR_GENERALIZED_TIME);
20 }

References start, and Botan::UTC_OR_GENERALIZED_TIME.

## ◆ set_padding_scheme()

void Botan::X509_Cert_Options::set_padding_scheme | ( | const std::string & | scheme | ) |

Choose a padding scheme different from the default for the key used.

Definition at line 63 of file x509opt.cpp.

64 {
65 padding_scheme = scheme;
66 }

References padding_scheme.

## Member Data Documentation

## ◆ challenge

std::string Botan::X509_Cert_Options::challenge

the subject challenge password

Definition at line 99 of file x509self.h.

Referenced by Botan::X509::create_cert_req().

## ◆ common_name

std::string Botan::X509_Cert_Options::common_name

the subject common name

Definition at line 29 of file x509self.h.

Referenced by X509_Cert_Options().

## ◆ constraints

Key_Constraints Botan::X509_Cert_Options::constraints

The key constraints for the subject public key

Definition at line 125 of file x509self.h.

Referenced by add_constraints(), Botan::X509::create_cert_req(), Botan::X509::create_self_signed_cert(), and X509_Cert_Options().

## ◆ country

std::string Botan::X509_Cert_Options::country

the subject counry

Definition at line 34 of file x509self.h.

Referenced by X509_Cert_Options().

## ◆ dns

std::string Botan::X509_Cert_Options::dns

the subject DNS

Definition at line 84 of file x509self.h.

## ◆ email

std::string Botan::X509_Cert_Options::email

the subject email adress

Definition at line 69 of file x509self.h.

## ◆ end

X509_Time Botan::X509_Cert_Options::end

the subject notAfter

Definition at line 108 of file x509self.h.

Referenced by Botan::X509::create_self_signed_cert(), not_after(), and X509_Cert_Options().

## ◆ ex_constraints

std::vector<OID> Botan::X509_Cert_Options::ex_constraints

The key extended constraints for the subject public key

Definition at line 130 of file x509self.h.

Referenced by add_ex_constraint(), Botan::X509::create_cert_req(), and Botan::X509::create_self_signed_cert().

## ◆ extensions

Extensions Botan::X509_Cert_Options::extensions

Additional X.509 extensions

Definition at line 135 of file x509self.h.

Referenced by Botan::X509::create_cert_req(), and Botan::X509::create_self_signed_cert().

## ◆ ip

std::string Botan::X509_Cert_Options::ip

the subject IPv4 address

Definition at line 79 of file x509self.h.

## ◆ is_CA

bool Botan::X509_Cert_Options::is_CA

Indicates whether the certificate request

Definition at line 113 of file x509self.h.

Referenced by CA_key(), Botan::X509::create_cert_req(), Botan::X509::create_self_signed_cert(), and X509_Cert_Options().

## ◆ locality

std::string Botan::X509_Cert_Options::locality

the subject locality

Definition at line 54 of file x509self.h.

## ◆ more_dns

std::vector<std::string> Botan::X509_Cert_Options::more_dns

additional subject DNS entries.

Definition at line 89 of file x509self.h.

## ◆ more_org_units

std::vector<std::string> Botan::X509_Cert_Options::more_org_units

additional subject organizational units.

Definition at line 49 of file x509self.h.

## ◆ org_unit

std::string Botan::X509_Cert_Options::org_unit

the subject organizational unit

Definition at line 44 of file x509self.h.

Referenced by X509_Cert_Options().

## ◆ organization

std::string Botan::X509_Cert_Options::organization

the subject organization

Definition at line 39 of file x509self.h.

Referenced by X509_Cert_Options().

## ◆ padding_scheme

std::string Botan::X509_Cert_Options::padding_scheme

Definition at line 120 of file x509self.h.

Referenced by Botan::X509::create_cert_req(), Botan::X509::create_self_signed_cert(), set_padding_scheme(), and X509_Cert_Options().

## ◆ path_limit

size_t Botan::X509_Cert_Options::path_limit

Indicates the BasicConstraints path limit

Definition at line 118 of file x509self.h.

Referenced by CA_key(), Botan::X509::create_cert_req(), Botan::X509::create_self_signed_cert(), and X509_Cert_Options().

## ◆ serial_number

std::string Botan::X509_Cert_Options::serial_number

the subject serial number

Definition at line 64 of file x509self.h.

## ◆ start

X509_Time Botan::X509_Cert_Options::start

the subject notBefore

Definition at line 104 of file x509self.h.

Referenced by Botan::X509::create_self_signed_cert(), not_before(), and X509_Cert_Options().

## ◆ state

std::string Botan::X509_Cert_Options::state

the subject state

Definition at line 59 of file x509self.h.

## ◆ uri

std::string Botan::X509_Cert_Options::uri

the subject URI

Definition at line 74 of file x509self.h.

## ◆ xmpp

std::string Botan::X509_Cert_Options::xmpp

the subject XMPP

Definition at line 94 of file x509self.h.

The documentation for this class was generated from the following files:

- src/lib/x509/x509self.h
- src/lib/x509/x509opt.cpp